﻿using EPiServer.Core;
using EPiServer.ServiceLocation;
using Fotoware.Plugins.Optimizely.Interfaces;
using Microsoft.Extensions.Configuration;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Configuration;
using System.IO;
using System.Linq;

namespace Fotoware.Plugins.Optimizely
{
    public class ExampleSiteTwoFotoWareSettings : IFotoWareSettings
    {
        private IConfiguration _configuration = ServiceLocator.Current.GetInstance<IConfiguration>();
        public ExampleSiteTwoFotoWareSettings()
        {
            MetadataConfiguration = new NameValueCollection
            {
                {"5", "Name"},
                {"25", "Keywords"},
                {"80", "Photographers"},
                {"116", "Copyright"},
                {"120", "Description"}
            };
        }

        public virtual string AllowedTypes => _configuration["FotoWare:AllowedTypes"]?? ".jpg,.jpeg,.jpe,.gif,.bmp,.png";

        public virtual string ClientId => "b024c993-d15d-4ddb-8ed6-3ea0e1cc5xxx";//change this

        public virtual string ClientSecret => "qgKUV34HqRtQ0tfNersr1QOkMrWUHTQBO5YDxveaxxx";//change this

        public virtual string ServerClientId => "832a27b3-e61d-4701-895e-06aefbde0xxx";//change this

        public virtual string ServerClientSecret => "0-NnV3g4AgybGBe0USUkUG8JbzbmeThlt5SPxLWexxx";//change this

        public string ServerAccessToken { get; set; }

        public DateTime ServerAccessTokenExpireTime { get; set; }

        public virtual string FotoWareTenantUrl => "https://showcase.fotoware.cloud";//change this

        /// <summary>
        /// Used in sheduled Job for full import
        /// </summary>
        public virtual IEnumerable<string> ArchiveUrlsToSynchronize
        {
            get
            {
               return Enumerable.Empty<string>();
            }
        }


        public virtual NameValueCollection MetadataConfiguration { get; set; }

        public virtual int PreferredDownloadWidth => 1200;

        public virtual string PresetUrl => _configuration["FotoWare:PresetUrl"];

        public virtual string RedirectUri => "http://localhost:45678/EPiServer/Fotoware.Plugins.Optimizely/Authentication/callback";//change this

        public virtual bool UseOauth => ServerClientId != null && ServerClientSecret != null;

        public virtual ContentReference RootFolderId => new ContentReference(644);//change this

        public virtual bool DisableEpiserverDefaultMediaSelector => false;

        public virtual bool EnableOnAllImages => true;

        public virtual bool ExportWidgetEnableOnAllImages => true;
    }
}